﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private IEnumerable<CStromkurveDatenpunkt> GenerateDataPoints()
        {
            var aCount = 10000;
            var aDatapoints = new List<CStromkurveDatenpunkt>(aCount);
            var aRnd = new Random();
            for (var aPos = 0; aPos < aCount; ++aPos)
            {
                var aDataPoint = new CStromkurveDatenpunkt();
                aDataPoint.Zeit = new TimeSpan(0, 0, 0, 0, aPos);
                aDataPoint.Stromspannung = aRnd.NextDouble();
                aDataPoint.Stromstärke = aRnd.NextDouble();
                aDatapoints.Add(aDataPoint);
            }
            return aDatapoints;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            var aMainWindow = this;
            var aDataPoints = this.GenerateDataPoints();
            var aDataChart = aMainWindow.DataChart;
            aDataChart.DataContext = aDataPoints;
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            var aMainWindow = this;
            var aDataPoints1 = this.GenerateDataPoints();
            var aDataPoints2 = this.GenerateDataPoints();
            var aDataChart = aMainWindow.DataChart;
            var aDispatcher = aMainWindow.Dispatcher;
            var aTask = System.Threading.Tasks.Task.Factory.StartNew(delegate()
            {
                while (true)
                {
                aDispatcher.Invoke(new Action(delegate()
                {
                    aDataChart.DataContext = aDataPoints1;
                }));
                aDispatcher.Invoke(new Action(delegate()
                {
                    aDataChart.DataContext = aDataPoints2;
                }));
                }
            });
 

        }
    }


    public sealed class CStromkurveDatenpunkt
    {
        public TimeSpan Zeit { get; set; }

        private double StromstärkeM;
        public double Stromstärke
        {
            get
            {
                return this.StromstärkeM;
            }
            set
            {
                this.StromstärkeM = value;
            }
        }
        private double StromspannungM;
        public double Stromspannung { get { return this.StromspannungM; } set { this.StromspannungM = value; } }
    }
}
